$Jarvis$，时间复杂度 $O(n^2)$

```cpp
bool croleft(poi a, poi b, poi c)
{
	return c.crosspro(b, a) < 0;
}

vector<int>res;

void jarvis(vector<poi>&s)
{
	sort(s.begin(), s.end());
	deque<int>dq;
	dq.push_back(0);
	dq.push_back(1);
	for (int i = 2; i < s.size(); i++)
	{
		while (dq.size() >= 2)
		{
			int t = dq.back();
			dq.pop_back();
			if (croleft(s[t], s[dq.back()], s[i]))
			{
				dq.push_back(t);
				break;
			}
		}
		dq.push_back(i);
	}
	for (int i = 0; i < dq.size(); i++)
	{
		res.emplace_back(dq[i]);
	}
	dq.clear();
	dq.push_back(s.size() - 1);
	dq.push_back(s.size() - 2);
	for (int i = s.size() - 3; i >= 0; i--)
	{
		while (dq.size() >= 2)
		{
			int t = dq.back();
			dq.pop_back();
			if (croleft(s[t], s[dq.back()], s[i]))
			{
				dq.push_back(t);
				break;
			}
		}
		dq.push_back(i);
	}
	for (int i = 0; i < dq.size(); i++)
	{
		res.emplace_back(dq[i]);
	}
}
```

$Graham$ 复杂度 $O(nlog(n))$

```cpp
bool croleft(poi a, poi b, poi c)
{
	return c.crosspro(b, a) < 0;
}

deque<int> graham(vector<poi>&s)
{//返回值为凸包点按顺序的在s中的下标
 //会将参数的vector数组排序
	sort(s.begin(), s.end());
	deque<int>dq;
	dq.push_back(0);
	dq.push_back(1);
	for (int i = 2; i < s.size(); i++)
	{
		while (dq.size() >= 2)
		{
			int t = dq.back();
			dq.pop_back();
			if (croleft(s[i], s[t], s[dq.back()]))
			{
				dq.push_back(t);
				break;
			}
		}
		dq.push_back(i);
	}
	int len = dq.size();
	dq.push_back(s.size() - 2);
	for (int i = s.size() - 3; i >= 0; i--)
	{
		while (dq.size() > len)
		{
			int t = dq.back();
			dq.pop_back();
			if (croleft(s[i], s[t], s[dq.back()]))
			{
				dq.push_back(t);
				break;
			}
		}
		dq.push_back(i);
	}
	return dq;
}
```

