```cpp
const ll mod = 998244353;
const ll G = 3;
//G为mod的原根
//G为3时常见的mod：998244353,1004535809,469762049
ll rev[maxn];

//可以顶替分治NTT

ll fpow(ll a, ll n, ll mod)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res = res % mod * a % mod;
		}
		a = a % mod * a % mod;
		n >>= 1;
	}
	return res;
}

void NTT(ll * s, int f, int n)
{
	for (ll i = 0; i < n; i++)
	{
		if (i < rev[i]) swap(s[i], s[rev[i]]);
	}
	for (ll i = 1; i < n; i <<= 1)
	{
		ll wn = fpow(G, (mod - 1) / (i << 1), mod);
		if (!~f) wn = fpow(wn, mod - 2, mod);
		ll p = i << 1;
		for (ll j = 0; j < n; j += p)
		{
			ll w = 1;
			for (ll k = 0; k < i; k++)
			{
				ll x = s[j + k];
				ll y = w * s[j + k + i];
				s[j + k] = x + y;
				s[j + k] %= mod;
				s[j + k + i] = x - y;
				s[j + k + i] %= mod;
				(s[j + k + i] += mod) %= mod;
				w *= wn;
				w %= mod;
			}
		}
	}
}

void getinvNTT(ll deg, ll* a, ll* b, ll* t)
{//求多项式 a 的逆元，结果保存在 b
	if (deg == 1)
	{
		b[0] = fpow(a[0], mod - 2, mod);
		return; 
	}
	getinvNTT((deg + 1) >> 1, a, b, t);
	ll len = 0;
	ll n = 1;
	while (n < (deg << 1))
	{
		n <<= 1;
		len++;
	}
	for (ll i = 1; i < n; i++)
	{
		rev[i] = (rev[i >> 1] >> 1) | ((i & 1) << (len - 1));
	}
	for (int i = 0; i < deg; i++) t[i] = a[i];
	for (int i = deg; i < n; i++) t[i] = 0;
	NTT(t, 1, n);
	NTT(b, 1, n);
	for (int i = 0; i < n; i++)
		b[i] = (2 - t[i] * b[i] % mod + mod) % mod * b[i] % mod;
	NTT(b, -1, n);
	ll inv = fpow(n, mod - 2, mod);
	for (int i = 0; i < n; i++) b[i] = b[i] * inv % mod;
	for (int i = deg; i < n; i++) b[i] = 0;
}
```

