```cpp
struct DSU
{
	int fa[maxn];
	int sz[maxn];	//以i为根的集合点数
	DSU()
	{
		for (int i = 1; i < maxn; i++)
		{
			fa[i] = i;
			sz[i] = 1;
		}
	}
	DSU(int n)
	{
		for (int i = 1; i <= n; i++)
		{
			fa[i] = i;
			sz[i] = 1;
		}
	}
	int find(int x)
	{
		if (fa[x] == x) return x;
		fa[x] = find(fa[x]);
		return fa[x];
	}
	bool check(int x, int y)
	{
		return find(x) == find(y);
	}
	void merge(int x, int y)
	{
		int fx = find(x);
		int fy = find(y);
		sz[fy] += sz[fx];
		fa[fx] = fy;
	}
	int size(int x)
	{
		return sz[find(x)];
	}
};
```

