求 $\displaystyle\sum_{i=1}^{n}\left\lfloor\frac{n}{i}\right\rfloor$

```cpp
for(int l=1,r;l<=n;l=r+1)
{
	r=n/(n/l);
	ans+=(r-l+1)*(n/l);
}
```

### 应用

求

$\displaystyle \sum_{i=1}^{n}k\%i$

展开

$\displaystyle \sum_{i=1}^{n}k-\left\lfloor\frac{k}{i}\right\rfloor\times i$

$\displaystyle n\times k-\sum_{i=1}^{n}\left\lfloor\frac{k}{i}\right\rfloor\times i$

进行数论分块，每一块 $[l,r]$ 都是公差为$\displaystyle \left\lfloor\frac{k}{l}\right\rfloor$ 的等差数列。

```cpp
#include<bits/stdc++.h>
using namespace std;

using ll=long long;

int main() {
	ll n,k;
	cin>>n>>k;
	ll ans=n*k;
	for(int l=1,r; l<=n; l=r+1) {
		if(k/l) r=min(k/(k/l),n);
		else r=n/(n/l);
		ans-=(k/l)*(r-l+1)*(l+r)/2;
	}
	cout<<ans;
	return 0;
}
```

### 整除分块与积性函数

积性函数有

$\displaystyle f(i\times j)=f(i)\times f(j)$

$f(i)$ 是一个完全积性函数。

莫比乌斯函数 $\mu$ 是完全积性函数。

(欧拉函数 $\displaystyle \phi$ 不是完全积性函数，$\displaystyle \phi(i\times j)=\phi(i)\times\phi(j)$ 当且仅当 $\gcd(i,j)=1$ 时成立)

类似如下的式子

$\displaystyle\sum_{i=1}^{n}\mu(i)*\left\lfloor\frac{n}{i}\right\rfloor$

通过积性函数的性质，可以通过对前半段的莫比乌斯函数维护一个前缀和，用整除分块处理式子的后半段，处理答案时将两段相乘即可。

即通过数论分块，每一块 $[l,r]$ 的结果是  $\displaystyle(\sum_{i=l}^{r} \mu(i) )*(r-l+1)*(n/l)$

在莫比乌斯反演推出的式子中常见。