```cpp
struct TreeArray
{
    int n;
    ll sum[maxn];

    TreeArray()
    {
        memset(sum, 0, sizeof(sum));
    }

    inline int lowbit(int x)
    {
        return x & (-x);
    }

    void update(int x, int k)
    {
        for (int i = x; i <= n; i += lowbit(i)) sum[i] += k;
    }

    ll get_sum(int x)
    {
        ll res = 0;
        for (int i = x; i; i -= lowbit(i))
        {
            res += sum[i];
        }
        return res;
    }

    ll query(int l, int r)
    {
        return get_sum(r) - get_sum(l - 1);
    }

    int build(int* a)
    {
        for (int i = 1; i <= n; i++)
        {
            update(i, a[i] - a[i - 1]);
        }
    }

    int update(int l, int r, int k)
    {
        update(l, k);
        update(r + 1, -k);
    }
}ta;
```

