```cpp
//a^b≡a^(b (mod phi[n]))(mod n)

ll euler(ll x)
{
	//1-x与x互质的数字的数量
	//1-x与x互质的数字总和为x*euler(x)/2
	//gcd(a,b)==1则euler(a*b)==euler(a)*euler(b)
	ll res = x;
	for (ll i = 2; i * i <= x; i++)
	{
		if (x % i) continue;
		res = res / i * (i - 1);
		while (x % i == 0) x /= i;
	}
	if (x != 1) res = res / x * (x - 1);
	return res;
    //单个数字,复杂度为sqrt(x)
}

int phi[maxn];

void euler(ll n)
{
	//基于Eratosthenes筛法，复杂度为nlogn
	for (int i = 1; i <= n; i++) phi[i] = i;
	for (int i = 2; i <= n; i++)
	{
		if (phi[i] == i)
		{
			prime.emplace_back(i);
			for (int j = i; j <= n; j += i)
			{
				phi[j] = phi[j] / i * (i - 1);
			}
		}
	}
    //1-n所有欧拉函数
}
//常用性质:gcd(a,b)==1 => gcd(a*k,b*k)==k
//据此使用前缀和计算gcd为k的pair的数量
//sum[i]=sum[i-1]+phi[i];
//gcd为k的数的pair的数量为sum[n / i] * 2LL - 1
//-1是因为1,1被重复计算，*2是因为gcd(x,y)==gcd(y,x)==k
//拓展欧拉定理 b≥φ(m)时,a^b(mod m)=a^((b mod φ(m))+φ(m))(mod m) ^为幂运算
//b<φ(m)时不一定成立，只能直接使用快速幂计算
//欧拉定理 当a,m互质时，a^φ(m)≡1(mod m)
```

