```cpp
struct poi
{//点
	double x, y;
	poi(double x = 0, double y = 0) :x(x), y(y) {}
	poi operator + (poi s)
	{
		return poi(x + s.x, y + s.y);
	}
	poi operator - (poi s)
	{
		return poi(x - s.x, y - s.y);
	}
	poi operator - ()
	{
		return symcopoi(poi(0, 0));
	}
	bool operator < (poi s)const
	{
		return y < s.y || y == s.y && x < s.x;
	}
	double operator * (poi s)
	{//向量othis叉乘os
		return x * s.y - y * s.x;
	}
	double dis(poi s)
	{
		return sqrt((x - s.x) * (x - s.x) + (y - s.y) * (y - s.y));
	}
	poi symcopoi(poi o)
	{//关于o对称的点
		poi res;
		res.x = 2 * o.x - x;
		res.y = 2 * o.y - y;
		return res;
	}
	double crosspro(poi a, poi b)
	{//oa叉乘ob,结果为向量a和b围成的平行四边形面积
		return (a.x - x) * (b.y - y) - (b.x - x) * (a.y - y);
	}
};

struct vec
{//向量 线段
	poi a, b;
	vec() :a(), b() {}
	vec(double x1, double y1, double x2, double y2) :a(x1, y1), b(x2, y2) {}
	vec(poi a, poi b) :a(a), b(b) {}
	vec operator + (vec s)
	{
		return vec(a + s.a, b + s.b);
	}
	vec operator - ()
	{
		return vec(-a, -b);
	}
	vec operator - (vec s)
	{
		return vec(a - s.a, b - s.b);
	}
	double dotpro(vec s)
	{//点乘
		vec t1(0, 0, b.x - a.x, b.y - a.y);
		vec t2(0, 0, s.b.x - s.a.x, s.b.y - s.a.y);
		return t1.b.x * t2.b.x + t1.b.y * t2.b.y;
	}
	double operator * (vec s)const
	{//叉乘 >0 this在s顺时针方向 <0 逆时针方向 =0 共线
		vec t1(0, 0, b.x - a.x, b.y - a.y);
		vec t2(0, 0, s.b.x - s.a.x, s.b.y - s.a.y);
		return t1.b.x * t2.b.y - t2.b.x * t1.b.y;
	}
	bool onseg(poi s)
	{//点是否在线段上
		bool res = fabs((s.x - a.x) * (b.y - a.y) - (b.x - a.x) * (s.y - a.y)) <= eps;
		res &= min(a.x, b.x) <= s.x && s.x <= max(a.x, b.x);
		res &= min(a.y, b.y) <= s.y && s.y <= max(a.y, b.y);
		return res;
	}
	bool across(vec s)
	{//判断线段是否相交
		bool res = max(a.x, b.x) >= min(s.a.x, s.b.x);
		res &= max(s.a.x, s.b.x) >= min(a.x, b.x);
		res &= max(a.y, b.y) >= min(s.a.y, s.b.y);
		res &= max(s.a.y, s.b.y) >= min(a.y, b.y);
		res &= vec(s.a, a) * vec(b, a) * (vec(b, a) * vec(s.b, a)) > 0;
		res &= vec(a, s.a) * vec(s.b, s.a) * (vec(s.b, s.a) * vec(b, s.a)) > 0;
		return res;
	}
	poi acropoi(vec s)
	{//交点 建议先判断是否相交 不相交返回INF
		if (!across(s)) return poi(-INF, -INF);
		poi res;
		res.x = vec(s.b, a) * vec(b, a) * s.a.x - vec(s.a, a) * vec(b, a) * s.b.x;
		res.x /= vec(s.b, a) * vec(b, a) - vec(s.a, a) * vec(b, a);
		res.y = vec(s.b, a) * vec(b, a) * s.a.y - vec(s.a, a) * vec(b, a) * s.b.y;
		res.y /= vec(s.b, a) * vec(b, a) - vec(s.a, a) * vec(b, a);
		return res;
	}
};

struct cle
{
	poi o;
	double r;
	cle() :o(), r(0) {}
	cle(poi o, double r) :o(o), r(r) {}
	cle(double ox, double oy, double r) :o(ox, oy), r(r) {}
	double area()const
	{
		return r * r * pi;
	}
	double area(cle s)const
	{
		double d = sqrt((o.x - s.o.x) * (o.x - s.o.x) + (o.y - s.o.y) * (o.y - s.o.y));
		if (d >= r + s.r) return 0;
		double r1 = r;
		double r2 = s.r;
		if (r1 > r2) swap(r1, r2);
		if (r2 - r1 >= d) return pi * r1 * r1;
		double angle1 = acos((r1 * r1 + d * d - r2 * r2) / (2 * r1 * d));
		double angle2 = acos((r2 * r2 + d * d - r1 * r1) / (2 * r2 * d));
		return angle1 * r1 * r1 + angle2 * r2 * r2 - r1 * d * sin(angle1);
	}
};

struct tri
{//三角形
	poi a, b, c;
	bool intri(poi s)
	{//点是否在三角形内
		vec AB, AC, PA, PB, PC;
		AB.a = a;
		AB.b = b;
		AC.a = a;
		AC.b = c;
		PA.a = s;
		PA.b = a;
		PB.a = s;
		PB.b = b;
		PC.a = s;
		PC.b = c;
		double Sabc = fabs(AB * AC);
		double Spab = fabs(PA * PB);
		double Spac = fabs(PA * PC);
		double Spbc = fabs(PB * PC);
		if (fabs((Spab + Spac + Spbc) - Sabc) < eps) return true;
		return false;
	}
	double area()
	{
		return fabs((b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y)) / 2;
	}
	cle circumout()
	{//外接圆
		cle res;
		double ta, tb, tc;
		ta = a.dis(b);
		tb = b.dis(c);
		tc = c.dis(a);
		res.r = ta * tb * tc / area() / 4;
		double xa = a.x, ya = a.y;
		double xb = b.x, yb = b.y;
		double xc = c.x, yc = c.y;
		double c1 = (xa * xa + ya * ya - xb * xb - yb * yb) / 2;
		double c2 = (xa * xa + ya * ya - xc * xc - yc * yc) / 2;
		res.o.x = (c1 * (ya - yc) - c2 * (ya - yb)) / ((xa - xb) * (ya - yc) - (xa - xc) * (ya - yb));
		res.o.y = (c1 * (xa - xc) - c2 * (xa - xb)) / ((ya - yb) * (xa - xc) - (ya - yc) * (xa - xb));
		return res;
	}
	cle circumin()
	{//内切圆
		cle res;
		double ta, tb, tc;
		ta = a.dis(b);
		tb = b.dis(c);
		tc = c.dis(a);
		res.r = 2 * area() / (ta + tb + tc);
		double ana = acos((tb * tb + tc * tc - ta * ta) / (2 * tb * tc));
		double anb = acos((ta * ta + tc * tc - tb * tb) / (2 * ta * tc));
		double anc = acos((ta * ta + tb * tb - tc * tc) / (2 * ta * tb));
		double p1 = sin(ana / 2);
		double p2 = sin(anb / 2);
		double p3 = sin(anc / 2);
		double xa = a.x, ya = a.y;
		double xb = b.x, yb = b.y;
		double xc = c.x, yc = c.y;
		double r = res.r;
		double f1 = ((r / p2) * (r / p2) - (r / p1) * (r / p1) + xa * xa - xb * xb + ya * ya - yb * yb) / 2;
		double f2 = ((r / p3) * (r / p3) - (r / p1) * (r / p1) + xa * xa - xc * xc + ya * ya - yc * yc) / 2;
		res.o.x = (f1 * (ya - yc) - f2 * (ya - yb)) / ((xa - xb) * (ya - yc) - (xa - xc) * (ya - yb));
		res.o.y = (f1 * (xa - xc) - f2 * (xa - xb)) / ((ya - yb) * (xa - xc) - (ya - yc) * (xa - xb));
		return res;
	}
};

struct pol
{//多边形
	vector<poi>a;
	poi& operator [] (int val)
	{
		return a[val];
	}
	bool inpol(poi s)
	{//点是否在多边形内
		if (a.empty()) return false;
		int cnt = 0;
		double x;
		poi t1, t2;
		t1 = a[0];
		for (int i = 1; i <= (int)a.size(); i++)
		{
			t2 = a[i % a.size()];
			if (t2.x == t1.x && t2.y == t1.y) continue;
			if (vec(t1, s).onseg(t2)) return true;
			if (
				min(t1.y, t2.y) <= s.y && s.y <= max(t1.y, t2.y) &&
				min(t1.x, t2.x) <= s.x && s.x <= max(t1.x, t2.x) &&
				t1.y != t2.y
				)
			{
				x = (s.y - t1.y) * (t2.x - t1.x) / (t2.y - t1.y) + t1.x;
				if (t1.x == t2.x || s.x <= x) cnt++;
			}
			t1 = t2;
		}
		return cnt % 2;
	}
	double area()
	{
		double res = 0;
		for (int i = 1; i < (int)a.size() - 1; i++)
		{
			poi ta(a[i] - a[0]), tb(a[i + 1] - a[0]);
			res += ta * tb;
		}
		return fabs(res) / 2;
	}
};

```

