```cpp
long long fpow(long long a, long long n, long long mod)
{
    if (n == 0)        return 1;
    else if (n & 1) return a * fpow(a, n - 1, mod) % mod;
    else
    {
        long long num = fpow(a, n / 2, mod) % mod;
        return num * num % mod;
    }
}

const int maxn = 1e6 + 10;
ll fac[maxn];
ll inv[maxn];

void getfacinv(int n, ll mod)
{//初始化fac和inv数组，获取1!-n!和相应的逆元 需要n<mod
    fac[0] = inv[0] = 1;
    for (int i = 1; i <= n; i++) fac[i] = fac[i - 1] * i % mod;
    inv[n] = fpow(fac[n], mod - 2, mod);
    for (int i = n - 1; i >= 1; i--) inv[i] = inv[i + 1] * (i + 1LL) % mod;
}
```

