## 浮点版

```cpp
double a[maxn][maxn];

int gauss(int n, int m)
{
	for (int i = 1; i <= n; i++)
	{
		int mxc = i;
		for (int j = i + 1; j <= n; j++)	//选出该列最大系数 
		{
			if (fabs(a[j][i]) > fabs(a[mxc][i])) mxc = j;
		}
		for (int j = 1; j <= n + 1; j++) swap(a[i][j], a[mxc][j]);
		if (fabs(a[i][i]) < eps) return -1;	//最大值等于0则该列都为0，无解 
		for (int j = 1; j <= n; j++)
		{
			if (i != j)
			{
				double t = a[j][i] / a[i][i];
				for (int k = i + 1; k <= n + 1; k++) a[j][k] -= a[i][k] * t;
			}
		}
	}
	//上述操作结束后，矩阵会变成这样
	/*
	k1*a=e1
	k2*b=e2
	k3*c=e3
	k4*d=e4
	*/
	//结果除以该项系数，消去常数
	for (int i = 1; i <= n; i++) a[i][n + 1] /= a[i][i];
}
```

```cpp
void guess()
{//必须有解
//s[i][1]+...+s[i][n]=b[i];
	for(int i=1;i<=n;i++)
	{
		for(int j=i;j<=n;j++)
		{
			if(fabs(s[j][i])>eps)
			{
				//行交换
				for(int k=1;k<=n;k++) swap(s[i][k],s[j][k]);
				swap(b[i],b[j]);
			}
		}
		for(int j=1;j<=n;j++)
		{
			if(i==j) continue;
			double rate=s[j][i]/s[i][i];
			for(int k=i;k<=n;k++)
			{//消元
				s[j][k]-=s[i][k]*rate;
			}
			b[j]-=b[i]*rate;
		}
	}
	//解x[i]=b[i]/s[i][i]
}
```



## kuangbin佬版

```cpp
#include<iostream>
#include<string>
#include<queue>
#include<stack>
#include<vector>
#include<map>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<set>
#include<list>
#include<iomanip>
#include<cstring>
#include<cmath>
#include<limits>
#include<cctype>
#include<unordered_map>
#include<complex>
#include<random>
#pragma warning(disable:4996)
using namespace std;

#define debug(i) cerr<<"<debug> "<<#i<<" "<<i<<" <\\debug>"<<endl
#define mfor(i,a,b) for(int i=(a);i<=(b);i++)
#define mrep(i,a,b) for(int i=(a);i>=(b);i--)
#define lll __int128
#define Re register
#define mem(a,b) memset(a,(b),sizeof(a))
#define Design ios::sync_with_stdio(0),cin.tie(0),cout.tie(0)
#define endl '\n'
#define toang(x) ((x)*180.0/pi)	//转角度
#define torad(x) ((x)*pi/180.0)	//转弧度
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> intpair;
typedef pair<ll, ll> llpair;
typedef long double ld;
typedef double dl;
const dl pi = acos(-1.0);
const dl eps = 1e-5;
const int INF = 0x3f3f3f3f;
const ll INFLL = 0x3f3f3f3f3f3f3f3f;

ll gcd(ll a, ll b)
{
	if (!b) return a;
	return gcd(b, a % b);
}

ll lcm(ll a, ll b)
{
	return a / gcd(a, b) * b;
}

const int maxn = 110;
const ll mod = 1e9 + 7;

ll a[maxn][maxn];//增广矩阵
ll x[maxn];//解集
bool free_x[maxn];//标记是否是不确定的变元

int gauss(ll equ, ll var)
{
    int i, j, k;
    int max_r;//当前这列绝对值最大的行
    int col;//当前处理的列
    ll ta, tb;
    ll LCM;
    ll temp;
    int free_x_num;
    int free_index;
    for (int i = 0; i <= var; i++)
    {
        x[i] = 0;
        free_x[i] = true;
    }
    //转换为阶梯阵
    col = 0;//处理当前的列
    for (k = 0; k < equ && col < var; k++, col++)
    {//枚举当前处理的行,找到该col列元素绝对值最大的那行与第k行交换.(为了在除法时减小误差)
        max_r = k;
        for (i = k + 1; i < equ; i++)
        {
            if (abs(a[i][col]) > abs(a[max_r][col])) max_r = i;
        }
        if (max_r != k)
        {//与第k行交换
            for (j = k; j < var + 1; j++) swap(a[k][j], a[max_r][j]);
        }
        if (a[k][col] == 0)
        {//说明该col列第k行一下全是0了,则处理当前行的下一列
            k--;
            continue;
        }
        for (i = k + 1; i < equ; i++)
        {//枚举要删去的行
            if (a[i][col] != 0)
            {
                LCM = lcm(abs(a[i][col]), abs(a[k][col]));
                ta = LCM / abs(a[i][col]);
                tb = LCM / abs(a[k][col]);
                if (a[i][col] * a[k][col] < 0) tb = -tb;//异号的情况是相加
                for (j = col; j < var + 1; j++)
                {
                    a[i][j] = ((a[i][j] * ta - a[k][j] * tb) % mod + mod) % mod;
                }
            }
        }
    }
    //1.无解的情况：化简的增广阵中存在(0,0,...,a)这样的行(a!=0)
    for (i = k; i < equ; i++)
    {//对于无穷解来说,如果要判断哪些是自由变元,那么初等行变换中的交换就会影响,则要记录交换
        if (a[i][col] != 0) return -1;
    }
    //2.无穷解的情况：在var*(var+1)的增广阵中出现(0,0,...,0)这样的行,说明没有形成严格的上三角阵
    //且出现的行数即为自由变元的个数
    if (k < var)
    {
        //首先自由变元有(var-k)个,即不确定的变元至少有(var-k)个
        for (i = k - 1; i >= 0; i--)
        {
            //第i行一定不会是(0,0,...,0)的情况,因为这样的行是在第k行到第equ行
            //同样,第i行一定不会是(0,0,...,a),a!=0的情况,这样的无解的
            free_x_num = 0;//用于判断该行中不确定的变元的合数,如果超过1个,则无法求解,他们仍然为不确定的变元
            for (j = 0; j < var; j++)
            {
                if (a[i][j] != 0 && free_x[j]) free_x_num++, free_index = j;
            }
            if (free_x_num > 1) continue;//无法求解出确定的变元
            //说明就只有一个不确定的变元free_index,那么可以求解出该变元,且该变元是确定的
            temp = a[i][var];
            for (j = 0; j < var; j++)
            {
                if (a[i][j] != 0 && j != free_index) temp -= a[i][j] * x[j] % mod;
                //temp -= (temp%MOD+MOD)%MOD;
            }
            //while(temp%a[i][free_index]!=0) temp+=MOD;
            x[free_index] = (temp / a[i][free_index]) % mod;//求出该变元
            free_x[free_index] = 0;//该变元是确定的
        }
        return (var - k);//自由变元有(var-k)个
    }
    //3.唯一解的情况：在var*(var+1)的增广阵中形成严格的上三角阵
    //计算出Xn-1,Xn-2,...,X0
    for (i = var - 1; i >= 0; i--)
    {
        temp = a[i][var];
        for (j = i + 1; j < var; j++)
        {
            if (a[i][j] != 0) temp -= a[i][j] * x[j];
            //temp = (temp%MOD+MOD)%MOD;
        }
        //while(temp%a[i][j]!=0) temp+=MOD;
        //if(temp%a[i][i]!=0) return -2;
        x[i] = temp / a[i][i];
    }
    return 0;
}

int main()
{
    int n, m;
    cin >> n >> m;
    mfor(i, 0, n - 1) mfor(j, 0, m) cin >> a[i][j];
    int free_num = gauss(n, m);
    if (free_num == -1) printf("No solution\n");
    else if (free_num == -2) printf("Float but no int solution\n");
    else if (free_num > 0)
    {
        printf("Infinite solution,自由变元个数为%d\n", free_num);
        for (int i = 0; i < n; i++)
        {
            if (free_x[i]) printf("x%d 是不确定的\n", i + 1);
            else printf("x%d: %d\n", i + 1, x[i]);
        }
    }
    else
    {
        for (int i = 0; i < m; i++)
        {
            printf("x%d: %d\n", i + 1, x[i]);
        }
    }
}
```

